VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cDisplay"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit


' CLASS LOCAL DECLARATIONS ...

Private Local_PrimaryTop As Long
Private Local_PrimaryLeft As Long
Private Local_PrimaryWidth As Long
Private Local_PrimaryHeight As Long
Private Local_MapPosH As Long
Private Local_MapPosV As Long
Private Local_PixelOffsetH As Long
Private Local_PixelOffsetV As Long
Private Local_MapWidth As Long
Private Local_MapHeight As Long
Private Local_PixelPosH As Long
Private Local_PixelPosV As Long
Private Local_UnitPosH As Long
Private Local_UnitPosV As Long

Private local_ScaleMode As dxsScaleMode
Private Local_DisplayType As dxsDisplayType
Private Local_ddSurface As DirectDrawSurface2
Private Local_Engine As Engine
Private Local_RedrawState As dxsRedrawState
Private Local_ddSurfaceDC As Long


' CLASS PROPERTYS ...

' Display dimensions
Friend Property Let PrimaryHeight(ByVal vData As Long)
    Local_PrimaryHeight = vData
End Property
Friend Property Get PrimaryHeight() As Long
    PrimaryHeight = Local_PrimaryHeight
End Property
Friend Property Let PrimaryWidth(ByVal vData As Long)
    Local_PrimaryWidth = vData
End Property
Friend Property Get PrimaryWidth() As Long
    PrimaryWidth = Local_PrimaryWidth
End Property
Friend Property Let PrimaryLeft(ByVal vData As Long)
    Local_PrimaryLeft = vData
End Property
Friend Property Get PrimaryLeft() As Long
    PrimaryLeft = Local_PrimaryLeft
End Property
Friend Property Let PrimaryTop(ByVal vData As Long)
    Local_PrimaryTop = vData
End Property
Friend Property Get PrimaryTop() As Long
    PrimaryTop = Local_PrimaryTop
End Property

' Parent object (engine instance)
Friend Property Set Parent(ByVal vData As Object)
    Set Local_Engine = vData
End Property
Friend Property Get Parent() As Engine
    Set Parent = Local_Engine
End Property

' Position of display within map
Friend Property Get UnitPosH() As Long
    UnitPosH = Local_UnitPosH
End Property
Friend Property Get UnitPosV() As Long
    UnitPosV = Local_UnitPosV
End Property
Friend Property Get MapPosH() As Long
    MapPosH = Local_MapPosH
End Property
Friend Property Get MapPosV() As Long
    MapPosV = Local_MapPosV
End Property
Friend Property Get MapWidth() As Long
    MapWidth = Local_MapWidth
End Property
Friend Property Get MapHeight() As Long
    MapHeight = Local_MapHeight
End Property
Friend Property Get PixelPosH() As Long
    PixelPosH = Local_PixelPosH
End Property
Friend Property Get PixelPosV() As Long
    PixelPosV = Local_PixelPosV
End Property
Friend Property Get PixelOffsetH() As Long
    PixelOffsetH = Local_PixelOffsetH
End Property
Friend Property Get PixelOffsetV() As Long
    PixelOffsetV = Local_PixelOffsetV
End Property

' Scale mode and position for external display position retrieval
Public Property Get ScaleMode() As dxsScaleMode
    ScaleMode = local_ScaleMode
End Property
Public Property Let ScaleMode(nNewMode As dxsScaleMode)
    local_ScaleMode = nNewMode
End Property
Public Property Get CurrentLeft() As Long
    Select Case local_ScaleMode
        Case dxsSMUnit
            CurrentLeft = Local_UnitPosH
        Case dxsSMPixel
            CurrentLeft = Local_PixelPosH
        Case dxsSMMap
            CurrentLeft = Local_MapPosH
    End Select
End Property
Public Property Get CurrentTop() As Long
    Select Case local_ScaleMode
        Case dxsSMUnit
            CurrentTop = Local_UnitPosV
        Case dxsSMPixel
            CurrentTop = Local_PixelPosV
        Case dxsSMUnit
            CurrentTop = Local_MapPosV
    End Select
End Property

' Redraw state
Friend Property Get RedrawState() As dxsRedrawState
    RedrawState = Local_RedrawState
End Property
Friend Property Let RedrawState(newRedrawState As dxsRedrawState)
    Local_RedrawState = newRedrawState
End Property

' Display type
Friend Property Get DisplayType() As dxsDisplayType
    DisplayType = Local_DisplayType
End Property

' ddSurface: Surface holding buffer for contents of display
Public Property Set ddSurface(ByVal vData As Object)
    Set Local_ddSurface = vData
End Property
Public Property Get ddSurface() As DirectDrawSurface2
    Set ddSurface = Local_ddSurface
End Property

' CLASS FUNCTIONS AND PROCEDURES...

' Initialize: Sets display size and type, creates directx objects
Friend Function Initialize(nLeft As Long, nTop As Long, nWidth As Long, nHeight As Long, nType As dxsDisplayType) As Boolean

    On Error GoTo E_Initialize
    Initialize = False
    
    ' Check settings for validity
    If nLeft < 0 Or nLeft > Local_Engine.PrimaryWidth Then
        Local_Engine.GenerateError 1001
        Exit Function
    End If
    If nWidth < 0 Or nWidth + nLeft > Local_Engine.PrimaryWidth Then
        Local_Engine.GenerateError 1001
        Exit Function
    End If
    If nTop < 0 Or nTop > Local_Engine.PrimaryHeight Then
        Local_Engine.GenerateError 1001
        Exit Function
    End If
    If nHeight < 0 Or nHeight + nTop > Local_Engine.PrimaryHeight Then
        Local_Engine.GenerateError 1001
        Exit Function
    End If
    
    ' Set position within window, set size in units
    Local_PrimaryLeft = nLeft
    Local_PrimaryTop = nTop
    Local_PrimaryWidth = nWidth
    Local_PrimaryHeight = nHeight
    Local_DisplayType = nType
    
    ' Set directdraw settings according to requested display type
    Select Case nType
    
        ' Viewport ... displays a part of the engine's map and objects
        Case dxsDTViewport
        
            ' Check if size is large enough
            If Local_PrimaryWidth < Local_Engine.TileSize Or Local_PrimaryHeight < Local_Engine.TileSize Then
                Local_Engine.GenerateError 1003
                Exit Function
            End If
            
            ' Check if size matches tileset
            If Local_PrimaryWidth Mod Local_Engine.TileSize > 0 Or Local_PrimaryHeight Mod Local_Engine.TileSize > 0 Then
                Local_Engine.GenerateError 1004
                Exit Function
            End If
            
            Set Local_ddSurface = Local_Engine.Toolbox.CreateSurface(Local_PrimaryWidth + Local_Engine.TileSize, Local_PrimaryHeight + Local_Engine.TileSize)
            
        ' Panel ... displays userdefined graphics
        Case dxsDTPanel
            Set Local_ddSurface = Local_Engine.Toolbox.CreateSurface(Local_PrimaryWidth, Local_PrimaryHeight)

        ' Radar ... displays map and objects as pixel
        Case dxsDTRadar
            Set Local_ddSurface = Local_Engine.Toolbox.CreateSurface(Local_PrimaryWidth, Local_PrimaryHeight)
        
    End Select
    
    ' Check surface existance
    If Local_ddSurface Is Nothing Then
        Local_Engine.GenerateError 1002
        Exit Function
    End If
    
    ' Set display init position to (1,1) in tiles
    Local_UnitPosH = Local_Engine.TileSize * 10
    Local_UnitPosV = Local_Engine.TileSize * 10
    RecalcCoordinates
    
    ' Enforce redrawing of display at next frame
    Local_RedrawState = dxsRSBackgroundTotal
    
    Initialize = True
    Exit Function
    
E_Initialize:

    Local_Engine.GenerateError 1000
    
End Function

' Locksurface: Returns the DC of a surface of panel type
Public Function LockSurface() As Long

    ' Enable error handling
    On Error GoTo E_LockSurface
    LockSurface = 0
    
    ' Check for display type validity
    If Local_DisplayType <> dxsDTPanel Then
        Exit Function
    End If
    
    ' Get DC from surface
    Local_ddSurface.Restore
    Local_ddSurface.GetDC Local_ddSurfaceDC
    
    ' Check validity of DC
    If Not Local_ddSurfaceDC > 0 Then
        Local_Engine.GenerateError 1701
        Exit Function
    End If
    
    ' Return DC
    LockSurface = Local_ddSurfaceDC
    Exit Function
    
E_LockSurface:
    
    Local_Engine.GenerateError 1700
    
End Function

' Unlocksurface: Unlocks the surface, marks display for redraw at next time
Public Sub UnlockSurface()

    ' Enable error handling
    On Error GoTo E_UnlockSurface
    
    ' Check for display type validity
    If Local_DisplayType <> dxsDTPanel Then
        Exit Sub
    End If
    
    ' Check existance of dc
    If Local_ddSurfaceDC = 0 Then
        Local_Engine.GenerateError 1801
        Exit Sub
    End If
    
    ' Release the dc
    Local_ddSurface.ReleaseDC Local_ddSurfaceDC
    
    ' Enforce redraw in next frame
    Local_RedrawState = dxsRSBackbufferTotal
    
    Exit Sub
    
E_UnlockSurface:
    
    Local_Engine.GenerateError 1800
    
End Sub


' Scroll: Move the display viewport to a new position
Public Function Scroll(ByVal nValueH As Long, ByVal nValueV As Long, nMode As dxsScrollMode) As Boolean

    Dim oldPixelH As Integer, oldPixelV As Integer  ' Variable to hold old values
    Dim oldMapH As Integer, oldMapV As Integer      ' Variable to hold old values
    
    ' Enable error handling
    On Error GoTo E_Scroll
    Scroll = False
    
    ' Check validity of tileset
    If Local_Engine.TileSize = 0 Then
        Local_Engine.GenerateError 1301
        Exit Function
    End If
    
    ' Absolute coordinates were passed ...
    If nMode = dxsAbsolute Then
        ' Set coordinates to fit in map
        If nValueH < 1 Then nValueH = 1
        If nValueH > (Local_Engine.MapUnitWidth - Local_PrimaryWidth * 10 - (Local_Engine.TileSize * 11)) Then nValueH = (Local_Engine.MapUnitWidth - Local_PrimaryWidth * 10 - (Local_Engine.TileSize * 11))
        If nValueV < 1 Then nValueV = 1
        If nValueV > (Local_Engine.MapUnitHeight - Local_PrimaryHeight * 10 - (Local_Engine.TileSize * 11)) Then nValueV = (Local_Engine.MapUnitHeight - Local_PrimaryHeight * 10 - (Local_Engine.TileSize * 11))
    End If
    
    ' Relative coordinates were passed ...
    If nMode = dxsRelative Then
        ' Set coordinates to fit in map
        nValueH = Local_UnitPosH + nValueH
        nValueV = Local_UnitPosV + nValueV
        If nValueH < 1 Then nValueH = 1
        If nValueH > (Local_Engine.MapUnitWidth - Local_PrimaryWidth * 10 - (Local_Engine.TileSize * 11)) Then nValueH = (Local_Engine.MapUnitWidth - Local_PrimaryWidth * 10 - (Local_Engine.TileSize * 11))
        If nValueV < 1 Then nValueV = 1
        If nValueV > (Local_Engine.MapUnitHeight - Local_PrimaryHeight * 10 - (Local_Engine.TileSize * 11)) Then nValueV = (Local_Engine.MapUnitHeight - Local_PrimaryHeight * 10 - (Local_Engine.TileSize * 11))
    End If
    
    ' Calculate old pixel values for comparation with new values
    oldPixelH = Local_UnitPosH \ 10
    oldPixelV = Local_UnitPosV \ 10
    
    oldMapH = (Local_UnitPosH \ 10) \ Local_Engine.TileSize
    oldMapV = (Local_UnitPosV \ 10) \ Local_Engine.TileSize
    
    ' Set new position
    Local_UnitPosH = nValueH
    Local_UnitPosV = nValueV
    Call RecalcCoordinates
    
    ' Enforce redrawing of display if viewport
    If Local_DisplayType = dxsDTViewport Then
    
        If Local_PixelPosH <> oldPixelH Or Local_PixelPosV <> oldPixelV Then
            If Local_MapPosH <> oldMapH Or Local_MapPosV <> oldMapV Then
                Local_Engine.RecalcAniSquareList
                Local_RedrawState = dxsRSBackgroundTotal
            Else
                Local_RedrawState = dxsRSBackbufferTotal
            End If
        End If
    End If
    
    If Local_DisplayType = dxsDTRadar Then
        Local_RedrawState = dxsRSBackgroundTotal
    End If
    
    Scroll = True
    Exit Function
    
E_Scroll:

    Local_Engine.GenerateError 1300
    
End Function

' Class termination: Release objects
Private Sub Class_Terminate()

    Set Local_Engine = Nothing
    
    If Not Local_ddSurface Is Nothing Then
        Set Local_ddSurface = Nothing
    End If
    
End Sub

' RecalcCoordinates: Recalculates all coordinates of display
Private Sub RecalcCoordinates()

    Local_PixelPosH = Local_UnitPosH \ 10
    Local_PixelPosV = Local_UnitPosV \ 10
    Local_MapPosH = Local_PixelPosH \ Local_Engine.TileSize
    Local_MapPosV = Local_PixelPosV \ Local_Engine.TileSize
    Local_MapWidth = Local_PrimaryWidth \ Local_Engine.TileSize
    Local_MapHeight = Local_PrimaryHeight \ Local_Engine.TileSize
    Local_PixelOffsetH = Local_PixelPosH - Local_MapPosH * Local_Engine.TileSize
    Local_PixelOffsetV = Local_PixelPosV - Local_MapPosV * Local_Engine.TileSize

End Sub

' EnforceRedraw: Enforces full redraw at next frame
Public Sub EnforceRedraw()

    Local_RedrawState = dxsRSBackgroundTotal
    
End Sub
