VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cDisplays"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"cDisplay"
Attribute VB_Ext_KEY = "Member0" ,"cDisplay"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit


' CLASS LOCAL DECLARATIONS ...

Private Local_Collection As Collection
Private Local_Engine As Engine
Private Local_Anisquares As cAniSquares


' CLASS PROPERTYS...

' AniSquares list
Friend Property Set Anisquares(ByVal vData As cAniSquares)
    Set Local_Anisquares = vData
End Property
Friend Property Get Anisquares() As cAniSquares
    Set Anisquares = Local_Anisquares
End Property

' Parent object (engine instance)
Friend Property Set Parent(ByVal vData As Object)
    Set Local_Engine = vData
End Property
Friend Property Get Parent() As Engine
    Set Parent = Local_Engine
End Property

' Item out of collection
Public Property Get Item(vntIndexKey As Variant) As cDisplay
  Set Item = Local_Collection(vntIndexKey)
End Property

' Number of items in collection
Public Property Get Count() As Long
    Count = Local_Collection.Count
End Property

' CLASS FUNCTIONS AND PROCEDURES...

' Add: Creates a new display
Public Function Add(nLeft As Long, nTop As Long, nWidth As Long, nHeight As Long, nType As dxsDisplayType, Optional sKey As String) As cDisplay

    Dim oNew As cDisplay    ' Variable to hold new member
    
    ' Create new member, pass along engine object
    Set oNew = New cDisplay
    Set oNew.Parent = Local_Engine
    
    ' Initialize display, check success
    If Not oNew.Initialize(nLeft, nTop, nWidth, nHeight, nType) Then
        Local_Engine.GenerateError 1100
        Set oNew = Nothing
        Exit Function
    End If
    
    ' Add new member to local collection
    If Len(sKey) = 0 Then
        Local_Collection.Add oNew
    Else
        Local_Collection.Add oNew, sKey
    End If

    ' Return created member
    Set Add = oNew
    Set oNew = Nothing

End Function

' Remove: Remove a display from the collection
Public Sub Remove(vntIndexKey As Variant)
    
    Local_Collection.Remove vntIndexKey
    
End Sub

' Class initialization: Create local collection
Private Sub Class_Initialize()
    
    Set Local_Collection = New Collection
    Set Local_Anisquares = New cAniSquares
    
End Sub

' Class termination: Release objects
Private Sub Class_Terminate()
    
    Set Local_Collection = Nothing
    Set Local_Engine = Nothing
    Set Local_Anisquares = Nothing
    
End Sub
