VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cSurface"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' CLASS LOCAL DECLARATIONS

Private Local_ddSurface As DirectDrawSurface2
Private Local_Engine As Engine

' CLASS PROPERTYS

' Parent object (engine instance)
Friend Property Set Parent(ByVal vData As Engine)
    Set Local_Engine = vData
End Property
Friend Property Get Parent() As Engine
    Set Parent = Local_Engine
End Property

' ddSurface object
Public Property Set ddSurface(ByVal vData As DirectDrawSurface2)
    Set Local_ddSurface = vData
End Property
Public Property Get ddSurface() As DirectDrawSurface2
    Set ddSurface = Local_ddSurface
End Property

' CLASS FUNCTIONS AND PROCEDURES

Public Function LoadFromFile(ByVal FileName As String) As Boolean

    ' Enable error handling
    On Error GoTo E_LoadFromFile
    LoadFromFile = False
    
    Dim tempSurface As DirectDrawSurface2   ' Variable to hold surface to be loaded
    
    ' Try to load bitmap
    Set tempSurface = Local_Engine.Toolbox.LoadBitmap(FileName)
    
    ' Check for load success
    If tempSurface Is Nothing Then
        Local_Engine.GenerateError 1901
        Exit Function
    End If
    
    ' Reset local surface
    If Not Local_ddSurface Is Nothing Then
        Set Local_ddSurface = Nothing
    End If
    
    ' Set local surface to loaded surface
    Set Local_ddSurface = tempSurface
    
    ' Reset temp surface
    Set tempSurface = Nothing
    
    ' Return success
    LoadFromFile = True
    Exit Function
    
E_LoadFromFile:
    Local_Engine.GenerateError 1900
    
End Function
' Render: Renders the contents of the surface onto another surface
Public Function Render(ByVal DestinationSurface As DirectDrawSurface2, ByVal nSourceLeft As Integer, ByVal nSourceTop As Integer, ByVal nSourceWidth As Integer, ByVal nSourceHeight As Integer, ByVal nDestLeft As Integer, ByVal nDestTop As Integer) As Boolean

    ' Enable error handling
    On Error GoTo E_Render
    Render = False
    
    ' Check validity of destination surface
    If DestinationSurface Is Nothing Then
        Local_Engine.GenerateError 2001
        Exit Function
    End If
    
    Dim rSrc As RECT        ' Variable to hold source coordinates
    
    ' Set source coordinates
    rSrc.Top = nSourceTop
    rSrc.Left = nSourceLeft
    rSrc.Bottom = nSourceTop + nSourceHeight
    rSrc.Right = nSourceLeft + nSourceWidth
    
    ' Render image
    DestinationSurface.BltFast nDestLeft, nDestTop, Local_ddSurface, rSrc, DDBLTFAST_NOCOLORKEY Or DDBLTFAST_WAIT
    
    ' Return success
    Render = True
    Exit Function
    
E_Render:

    Local_Engine.GenerateError 2000
    
End Function
' Termination: Reset surface
Private Sub Class_Terminate()

    If Not Local_ddSurface Is Nothing Then
        Set Local_ddSurface = Nothing
    End If
    
End Sub
