VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cSurfaces"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit


' CLASS LOCAL DECLARATIONS ...

Private Local_Collection As Collection
Private Local_Engine As Engine

' CLASS PROPERTYS...

' Parent object (engine instance)
Friend Property Set Parent(ByVal vData As Object)
    Set Local_Engine = vData
End Property
Friend Property Get Parent() As Engine
    Set Parent = Local_Engine
End Property

' Item out of collection
Public Property Get Item(vntIndexKey As Variant) As cSurface
  Set Item = Local_Collection(vntIndexKey)
End Property

' Number of items in collection
Public Property Get Count() As Long
    Count = Local_Collection.Count
End Property

' CLASS FUNCTIONS AND PROCEDURES...

' Add: Creates a new surface
Public Function Add(Optional sFileName As String, Optional sKey As Variant) As cSurface

    Dim oNew As cSurface    ' Variable to hold new member
    
    ' Enable error handling
    On Error GoTo E_Add
    
    ' Create new member, pass along engine object
    Set oNew = New cSurface
    Set oNew.Parent = Local_Engine
    
    ' Try to load file if name provided
    If Len(sFileName) > 0 Then
        If Not oNew.LoadFromFile(sFileName) Then
            Local_Engine.GenerateError 2101
            Exit Function
        End If
    End If
    
    ' Add new member to local collection
    If Len(sKey) = 0 Then
        Local_Collection.Add oNew
    Else
        Local_Collection.Add oNew, sKey
    End If

    ' Return created member
    Set Add = oNew
    Set oNew = Nothing

    Exit Function

E_Add:

    Local_Engine.GenerateError 2100
    
End Function

' Remove: Remove a surface from the collection
Public Sub Remove(vntIndexKey As Variant)
    
    Local_Collection.Remove vntIndexKey
    
End Sub
' Clear all surfaces
Public Sub Clear()
    Do While Local_Collection.Count > 1
        Local_Collection.Remove 1
    Loop
End Sub

' Class initialization: Create local collection
Private Sub Class_Initialize()
    
    Set Local_Collection = New Collection
    
End Sub

' Class termination: Release objects
Private Sub Class_Terminate()
    
    Set Local_Collection = Nothing
    Set Local_Engine = Nothing
    
End Sub

