VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cToolbox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' API SPECIFIC DECLARATIONS...

' Constants for use with win32 API
Private Const IMAGE_BITMAP = 0
Private Const LR_LOADFROMFILE = &H10
Private Const LR_CREATEDIBSECTION = &H2000
Private Const SRCCOPY = &HCC0020

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

' Types for use with win32 API
Private Type BITMAP
        bmType          As Long
        bmWidth         As Long
        bmHeight        As Long
        bmWidthBytes    As Long
        bmPlanes        As Integer
        bmBitsPixel     As Integer
        bmBits          As Long
End Type

' Single Pixel manipulation
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function SetPixelV Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

' Device context manipulation
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long

' Bitmap manipulation
Private Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long



' CLASS LOCAL DECLARATIONS ...
Private Local_Engine As Engine


' CLASS PROPERTYS ...

' Parent object (engine instance)
Friend Property Set Parent(ByVal vData As Object)
    Set Local_Engine = vData
End Property
Friend Property Get Parent() As Engine
    Set Parent = Local_Engine
End Property


' CLASS FUNCTIONS AND PROCEDURES...

' Loadbitmap method: Load a bitmap from file and store it in returned surface
Public Function LoadBitmap(ByVal FileName As String) As DirectDrawSurface2

    Dim hBitmap As Long                 ' Handle on bitmap
    Dim dBitmap As BITMAP               ' Handle on bitmap descriptor
    Dim tempDXD As DDSURFACEDESC        ' Surface description
    Dim TempDXS As DirectDrawSurface2   ' Created surface
    Dim dcBitmap As Long                ' Handle on image
    Dim dcDXS As Long                   ' Handle on surface context
   
    ' Enable error handling
    On Error GoTo E_LoadBitmap
   
    ' Check for file existance
    On Error GoTo E_LoadBitmap_NoFile
    Open FileName For Input As #1
    Close #1
    On Error GoTo E_LoadBitmap
    
    ' Load bitmap
    hBitmap = LoadImage(ByVal 0&, FileName, 0, 0, 0, LR_LOADFROMFILE Or LR_CREATEDIBSECTION)
    
    ' Check for validity of bitmap handle
    If hBitmap < 1 Then
        Local_Engine.GenerateError 702
        Exit Function
    End If
    
    ' Get bitmap descriptor
    GetObject hBitmap, Len(dBitmap), dBitmap
    
    ' Fill DX surface description
    With tempDXD
        .dwSize = Len(tempDXD)
        .dwFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
        .DDSCAPS.dwCaps = DDSCAPS_OFFSCREENPLAIN
        .dwWidth = dBitmap.bmWidth
        .dwHeight = dBitmap.bmHeight
    End With
    
    ' Create DX surface
    Local_Engine.DDInstance.CreateSurface tempDXD, TempDXS, Nothing
    
    ' Check surface existance
    If TempDXS Is Nothing Then
        Local_Engine.GenerateError 703
        Exit Function
    End If
    
    ' Create API memory DC
    dcBitmap = CreateCompatibleDC(ByVal 0&)
    
    ' Check API memory DC existance
    If dcBitmap < 1 Then
        Local_Engine.GenerateError 704
        Exit Function
    End If
    
    ' Select the bitmap into API memory DC
    SelectObject dcBitmap, hBitmap
    
    ' Restore DX surface
    TempDXS.Restore
    
    ' Get DX surface API DC
    TempDXS.GetDC dcDXS
    
    ' Blit BMP from API DC into DX DC using standard API BitBlt
    StretchBlt dcDXS, 0, 0, tempDXD.dwWidth, tempDXD.dwHeight, dcBitmap, 0, 0, dBitmap.bmWidth, dBitmap.bmHeight, SRCCOPY
    
    ' Cleanup
    TempDXS.ReleaseDC dcDXS
    DeleteDC dcBitmap
    DeleteObject hBitmap
    
    ' Return created DX surface
    Set LoadBitmap = TempDXS
    
    Exit Function
    
E_LoadBitmap:
    
    Local_Engine.GenerateError 700
    Exit Function
    
E_LoadBitmap_NoFile:

    Local_Engine.GenerateError 701

End Function

' Createsurface method: Create a new offscreen plain
Public Function CreateSurface(ByVal nWidth As Integer, ByVal nHeight As Integer) As DirectDrawSurface2

    ' Enable error handling
    On Error GoTo E_CreateSurface
    
    Dim tempDXD As DDSURFACEDESC    ' Variable holding temporary surface description
    
    ' Fill surface description
    With tempDXD
       .dwSize = Len(tempDXD)
       .dwFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
       .DDSCAPS.dwCaps = DDSCAPS_OFFSCREENPLAIN
       .dwWidth = nWidth
       .dwHeight = nHeight
    End With
    
    ' Create surface from description
    Local_Engine.DDInstance.CreateSurface tempDXD, CreateSurface, Nothing
    
    ' Check for existance of surface
    If CreateSurface Is Nothing Then
        Local_Engine.GenerateError 601
        Exit Function
    End If
    
    Exit Function
    
E_CreateSurface:
            
    Local_Engine.GenerateError 600

End Function

' Class termination: Release objects
Private Sub Class_Terminate()

    Set Local_Engine = Nothing
    
End Sub
